package org.apache.hadoop.dumbo;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileStatus;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileSplit;
import org.apache.hadoop.mapred.RecordReader;

public class CatPath {

	public static void main(String[] args) throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);

		Path inputPath = new Path(args[1]);
		List<FileStatus> inputFiles = new ArrayList<FileStatus>(); 

		FileStatus status = fs.getFileStatus(inputPath);
		if(status.isDir()) {
			FileStatus[] files = fs.listStatus(inputPath);
			Collections.addAll(inputFiles, files);
		} else {
			inputFiles.add(status);
		}

		for (FileStatus fileStatus : inputFiles) {
			FileSplit split = new FileSplit(fileStatus.getPath(), 0, 
					fileStatus.getLen()*fileStatus.getBlockSize(), (String[])null);
			RecordReader<Text,Text> reader = null;
			if (args[0].toLowerCase().equals("sequencefileascode"))
				reader = new SequenceFileAsCodeRecordReader(conf, split);
			else
				reader = new TextAsCodeRecordReader(conf, split);
			Text key = new Text(), value = new Text();
			while(reader.next(key, value)) {
				System.out.println(key.toString() + "\t" + value.toString());
			}
			reader.close();
		}
		  
	}
}
